import { Options } from 'recast';
import { P as ProxifiedModule, a as Proxified, G as GenerateOptions } from './types-ce2d4a09.js';
export { C as CodeFormatOptions, I as ImportItemInput, L as Loc, b as ParsedFileNode, d as ProxifiedArray, e as ProxifiedFunctionCall, h as ProxifiedImportItem, g as ProxifiedImportsMap, f as ProxifiedObject, i as ProxifiedValue, c as ProxyBase, j as ProxyType, T as Token, k as detectCodeFormat } from './types-ce2d4a09.js';
import { Node } from '@babel/types';
export { Node as ASTNode } from '@babel/types';

declare function parseModule<Exports extends object = any>(code: string, options?: Options): ProxifiedModule<Exports>;
declare function parseExpression<T>(code: string, options?: Options): Proxified<T>;
declare function generateCode(node: {
    $ast: Node;
} | Node | ProxifiedModule<any>, options?: GenerateOptions): {
    code: string;
    map?: any;
};
declare function loadFile<Exports extends object = any>(filename: string, options?: Options): Promise<ProxifiedModule<Exports>>;
declare function writeFile(node: {
    ast: Node;
} | Node, filename?: string, options?: Options): Promise<void>;

interface MagicastErrorOptions {
    ast?: Node;
    code?: string;
}
declare class MagicastError extends Error {
    rawMessage: string;
    options?: MagicastErrorOptions;
    constructor(message: string, options?: MagicastErrorOptions);
}

declare const builders: {
    functionCall(callee: string, ...args: any[]): Proxified;
    literal(value: any): Proxified;
};

export { GenerateOptions, MagicastError, MagicastErrorOptions, Proxified, ProxifiedModule, builders, generateCode, loadFile, parseExpression, parseModule, writeFile };
